/**
 * MySDL - A multimedia framework based on SDL and OpenGL
 * Copyright (C) 2006 Marian Schedenig (marian@musgit.com)
 * http://www.musgit.com/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#include "containers.h"
#include "xml.h"

namespace mysdl
{
	namespace gui
	{
		// ================================================================
		//  Pane
		// ================================================================

		/*
		 * See header file for documentation.
		 */
		Pane::Pane() : Component(),style(0)
		{
		}

		/*
		 * See header file for documentation.
		 */
		void Pane::setStyle(RectStyle *style)
		{
			this->style=style;
		}

		/*
		 * See header file for documentation.
		 */
		RectStyle *Pane::getStyle()
		{
			return(style);
		}

		/*
		 * See header file for documentation.
		 */
		void Pane::getSelfFromNode(const xml::Node *node,GUI *gui)
		{
			//debug::addMessage("Pane::getSelfFromNode()");

			Component::getSelfFromNode(node,gui);

			if(const std::string *style=node->getAttribute(XML_GUI_STYLE))
			{
				this->style=dynamic_cast<RectStyle *>((*gui->getStyles())[*style]);
			}

			//debug::removeMessage();
		}

		/*
		 * See header file for documentation.
		 */
		void Pane::drawSelf()
		{
			//debug::addMessage("Pane::drawSelf()");

			if(style)
			{
				Rect rect;
				rect.pos=Vector2D(0,0);
				rect.dimensions=dimensions;
				style->draw(rect);
			}

			//debug::removeMessage();
		}
	};
};
