/**
 * MySDL - A multimedia framework based on SDL and OpenGL
 * Copyright (C) 2006 Marian Schedenig (marian@musgit.com)
 * http://www.musgit.com/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#include <iostream>
#include <stdio.h>

#include <expat.h>

#include "debug.h"
#include "tools.h"

namespace mysdl
{
	/** TODO: ? */
	int fpsResolution=10;

	/*
	 * See header file for documentation.
	 */
  int calcFPS(int ticks)
  {
		static int sampleCount=0;
		static int tickCount=0;
    static int fps=0;

		sampleCount++;
		tickCount+=ticks;

		if(sampleCount>=fpsResolution)
		{
			sampleCount-=fpsResolution;
			fps=(int)((fpsResolution*1000.0/(double)tickCount)+0.5);
			tickCount=0;
		}

    return(fps);
  }

	/*
	 * See header file for documentation.
	 */
  Uint32 getElapsedTicks()
  {
    static Uint32 ticks=0,ticks2=0,diff=0;

    ticks2=SDL_GetTicks();
    diff=ticks2-ticks;
    ticks=ticks2;

    return(diff);
  }

	/*
	 * See header file for documentation.
	 */
	Uint32 getCurrentTicks()
	{
		return(SDL_GetTicks());
	}
}
